﻿

'********************************************************************************
'If you should have any comments, suggestions or improvements to these samples,
'we welcome you to contact us at SampleCode@melissadata.com also please visit our
'developers bulletin board at forum.melissadata.com.
'********************************************************************************


Imports System.Web
Imports System.Net
Imports System.IO
Imports System.Text
Imports System.Xml
Imports System.Xml.XmlWriter
Imports System.Xml.Serialization
Imports System.Windows.Forms



Public Class Form1

    '*********************************************************************
    ' A valid Customer ID is required to access Melissa Data's
    ' WebSmart Services. Please call our Sales department
    ' at 1-800-635-4772 x3 to request for a valid Customer ID.
    '*********************************************************************

    Dim ReqSS As New dqwsStreetSearch.Request
    Dim ResSS As New dqwsStreetSearch.ResponseArray
    Dim SSClient As dqwsStreetSearch.ServiceClient
    Dim isInitializedSS As Boolean = False

    Dim recordCount As Integer = 0
    Dim TotalRecords As Integer = 1
    Dim XmlSer As XmlSerializer
    Dim fs As FileStream


    '***************************************************************************
    ' Function to process the Street Search request
    '***************************************************************************
    Private Sub btnDoStreetSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDoStreetSearch.Click

        ' Clear the XML Each Time
        webBrowser1.Navigate("about:blank")
        webBrowser2.Navigate("about:blank")


        ' Set the input fields for current record
        ReqSS = New dqwsStreetSearch.Request
        ReqSS.AddressLine = txtAddress.Text
        ReqSS.City = txtCity.Text
        ReqSS.Country = txtCountry.Text
        ReqSS.CustomerID = txtCustomerID.Text
        ReqSS.State = txtState.Text
        ReqSS.TransmissionReference = "Testing: DQWS SOAP Sample Code implementation using single record input."
        ReqSS.Zip = txtZip.Text

        If (chkInRangeOnly.Checked) Then
            ReqSS.OptInRangeOnly = "true"
        Else
            ReqSS.OptInRangeOnly = "false"
        End If

        SSClient = New dqwsStreetSearch.ServiceClient("BasicHttpBinding_IService", "https://streetsearch.melissadata.net/v2/SOAP/Service.svc")


        Try
            ' Perform IPLocation Interface and store results to the Response
            ResSS = SSClient.doStreetSearch(ReqSS)
        Catch ex As Exception
            MessageBox.Show(ex.ToString, "Error")
            Return
        End Try


        ' Perform Outputting first record onto the output fields
        ' Must be initialized Correctly to continue
        isInitializedSS = True
        PopulateFieldsSS()

        ' Create an XML Serializer
        XmlSer = New XmlSerializer(ReqSS.GetType)

        ' Read in XML filestream and then output it to the AxtiveX Web Browser
        fs = New FileStream((System.Environment.CurrentDirectory + "\Request.xml"), FileMode.Create)
        XmlSer.Serialize(fs, ReqSS)
        fs.Close()
        webBrowser1.Navigate(System.Environment.CurrentDirectory + "\Request.xml")

        setResultCodeDefinition(ResSS.Results)

        If (isInitializedSS) Then


            ' Create an XML Serializer
            XmlSer = New XmlSerializer(ResSS.GetType)

            ' Read in XML filestream and then output it to the AxtiveX Web Browser
            fs = New FileStream((System.Environment.CurrentDirectory + "\Response.xml"), FileMode.Create)
            XmlSer.Serialize(fs, ResSS)
            fs.Close()
            webBrowser2.Navigate(System.Environment.CurrentDirectory + "\Response.xml")


        End If
    End Sub



    '***************************************************************************
    ' Functions to Populate The SS Data Grid
    '***************************************************************************
    Private Sub PopulateFieldsSS()

        ' Clear the Table
        If dgvResults.Rows.Count > 0 Then
            dgvResults.Rows.Clear()
        End If


        ' Initialize Column Headers
        dgvResults.Columns.Add("Record ID", "Record ID")
        dgvResults.Columns.Add("Company", "Company")
        dgvResults.Columns.Add("Range High", "Range High")
        dgvResults.Columns.Add("Range Low", "Range Low")
        dgvResults.Columns.Add("Range OddEven", "Range OddEven")
        dgvResults.Columns.Add("Street PreDir", "Street PreDir")
        dgvResults.Columns.Add("Street PostDir", "Street PostDir")
        dgvResults.Columns.Add("Street Name", "Street Name")
        dgvResults.Columns.Add("Street Suffix", "Street Suffix")
        dgvResults.Columns.Add("Suite Name", "Suite Name")
        dgvResults.Columns.Add("Suite High", "Suite High")
        dgvResults.Columns.Add("Suite Low", "Suite Low")
        dgvResults.Columns.Add("Suite OddEven", "Suite OddEven")
        dgvResults.Columns.Add("Zip5", "Zip5")
        dgvResults.Columns.Add("Zip+4 High", "Zip+4 High")
        dgvResults.Columns.Add("Zip+4 Low", "Zip+4 Low")
        dgvResults.Columns.Add("Carrier Route", "Carrier Route")
        dgvResults.Columns.Add("Urb Name", "Urb Name")
        dgvResults.Columns.Add("Urb Code", "Urb Code")
        dgvResults.Columns.Add("AddressType", "AddressType")
        dgvResults.Columns.Add("LACS Indicator", "LACS Indicator")
        dgvResults.Columns.Add("BaseAlternateIndicator", "BaseAlternateIndicator")


        Dim totalResults As Integer

        totalResults = Convert.ToInt32(ResSS.TotalRecords)

        Dim recordCounter As Integer

        recordCounter = 0

        While recordCounter < totalResults

            ' Populate the Row
            dgvResults.Rows.Add()

            dgvResults.Rows(recordCounter).Cells("Record ID").Value = ResSS.StreetRecord(recordCounter).RecordID
            dgvResults.Rows(recordCounter).Cells("Range High").Value = ResSS.StreetRecord(recordCounter).PrimaryRange.High
            dgvResults.Rows(recordCounter).Cells("Range Low").Value = ResSS.StreetRecord(recordCounter).PrimaryRange.Low
            dgvResults.Rows(recordCounter).Cells("Range OddEven").Value = ResSS.StreetRecord(recordCounter).PrimaryRange.OddEven
            dgvResults.Rows(recordCounter).Cells("Street PreDir").Value = ResSS.StreetRecord(recordCounter).Street.PreDirection
            dgvResults.Rows(recordCounter).Cells("Street PostDir").Value = ResSS.StreetRecord(recordCounter).Street.PostDirection
            dgvResults.Rows(recordCounter).Cells("Street Name").Value = ResSS.StreetRecord(recordCounter).Street.Name
            dgvResults.Rows(recordCounter).Cells("Street Suffix").Value = ResSS.StreetRecord(recordCounter).Street.Suffix
            dgvResults.Rows(recordCounter).Cells("Suite Name").Value = ResSS.StreetRecord(recordCounter).Suite.Name
            dgvResults.Rows(recordCounter).Cells("Suite High").Value = ResSS.StreetRecord(recordCounter).Suite.High
            dgvResults.Rows(recordCounter).Cells("Suite Low").Value = ResSS.StreetRecord(recordCounter).Suite.Low
            dgvResults.Rows(recordCounter).Cells("Suite OddEven").Value = ResSS.StreetRecord(recordCounter).Suite.OddEven
            dgvResults.Rows(recordCounter).Cells("Zip5").Value = ResSS.StreetRecord(recordCounter).Zip.Zip5
            dgvResults.Rows(recordCounter).Cells("Zip+4 High").Value = ResSS.StreetRecord(recordCounter).Zip.Plus4High
            dgvResults.Rows(recordCounter).Cells("Zip+4 Low").Value = ResSS.StreetRecord(recordCounter).Zip.Plus4Low
            dgvResults.Rows(recordCounter).Cells("Carrier Route").Value = ResSS.StreetRecord(recordCounter).CarrierRoute
            dgvResults.Rows(recordCounter).Cells("Urb Name").Value = ResSS.StreetRecord(recordCounter).Urbanization.Name
            dgvResults.Rows(recordCounter).Cells("Urb Code").Value = ResSS.StreetRecord(recordCounter).Urbanization.Code
            dgvResults.Rows(recordCounter).Cells("AddressType").Value = ResSS.StreetRecord(recordCounter).AddressType
            dgvResults.Rows(recordCounter).Cells("LACS Indicator").Value = ResSS.StreetRecord(recordCounter).LACSIndicator
            dgvResults.Rows(recordCounter).Cells("BaseAlternateIndicator").Value = ResSS.StreetRecord(recordCounter).BaseAlternateIndicator


            recordCounter = recordCounter + 1

        End While

    End Sub


    '***************************************************************************
    ' Define the result codes returned and show it to the results text box.
    '***************************************************************************
    Private Sub setResultCodeDefinition(ByVal resultCodes As String)
       
        Dim errorCodeList As String() = Nothing

        errorCodeList = resultCodes.Split(",")


        For Each resultCode In errorCodeList

            txtSSResults.Text = " "

            If resultCode = "SE01" Then
                txtSSResults.Text += resultCode + ": Web Service Internal Error;  "
            ElseIf resultCode = "GE01" Then
                txtSSResults.Text += resultCode + ": Empty XML Request Structure;  "
            ElseIf resultCode = "GE02" Then
                txtSSResults.Text += resultCode + ": Empty XML Request Record Structure;  "
            ElseIf resultCode = "GE03" Then
                txtSSResults.Text += resultCode + ": Counted records send more than number of records allowed per request;  "
            ElseIf resultCode = "GE04" Then
                txtSSResults.Text += resultCode + ": CustomerID empty;  "
                MessageBox.Show("Please enter your Customer ID", "Invalid Customer ID")
            ElseIf resultCode = "GE05" Then
                txtSSResults.Text += resultCode + ": CustomerID not valid;  "
                MessageBox.Show("The Customer ID your entered is invalid. To retrieve a valid " & _
                         "Customer ID, please contact a Melissa Data Sales Representative " & _
                         "at 800-MELISSA ext. 3 (800-800-6245 ext. 3). ", "Invalid Customer ID")
            ElseIf resultCode = "GE06" Then
                txtSSResults.Text += resultCode + ": CustomerID disabled;  "
                MessageBox.Show("The Customer ID your entered has been disabled. " & _
                     "Please contact a Melissa Data Sales Representative " & _
                     "at 800-MELISSA ext. 3 (800-800-6245 ext. 3). ", "Disabled Customer ID")
            ElseIf resultCode = "GE07" Then
                txtSSResults.Text += resultCode + ": XML Request invalid;  "

            ElseIf resultCode = "SS01" Then
                txtSSResults.Text += resultCode + ": OptInRangeOnly = True returned 1 or more results;  "
            ElseIf resultCode = "SS02" Then
                txtSSResults.Text += resultCode + ": OptInRangeOnly = False returned 1 or more results;  "
            ElseIf resultCode = "SS03" Then
                txtSSResults.Text += resultCode + ": 1000 street records returned but more than 1000 was found. Please narrow your search;  "
            ElseIf resultCode = "DE01" Then
                txtSSResults.Text += resultCode + ": Required Input Missing;  "
            ElseIf resultCode = "DE02" Then
                txtSSResults.Text += resultCode + ": No street records found;  "
            End If
        Next

    End Sub


    '***************************************************************************
    ' Function to clear the current input
    '***************************************************************************
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        txtAddress.Clear()
        txtCity.Clear()
        txtCountry.Clear()
        txtState.Clear()
        txtZip.Clear()
    End Sub


End Class
